"use strict";

exports.__esModule = true;
exports["default"] = Popper;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function Popper(getDeps, props) {
  var _getDeps = getDeps(),
    createPopper = _getDeps.createPopper,
    getPopperMaxHeight = _getDeps.getPopperMaxHeight,
    getClassName = _getDeps.getClassName,
    clk = _getDeps.clk;
  var TabsComponent = props.TabsComponent,
    instance = props.instance,
    hiddenTabIDs = props.hiddenTabIDs,
    btnRef = props.btnRef;
  var popperRef = (0, _react.useRef)();
  var ref = (0, _react.useRef)();
  ref.current = ref.current || {};
  (0, _react.useLayoutEffect)(function () {
    popperRef.current.style.maxHeight = getPopperMaxHeight(btnRef.current, 15) + 'px';
    var popperIns = createPopper(btnRef.current, popperRef.current);
    ref.current.popperIns = popperIns;
    return function () {
      popperIns.destroy();
    };
  }, []);
  (0, _react.useLayoutEffect)(function () {
    ref.current && ref.current.popperIns && ref.current.popperIns.update();
  }, [hiddenTabIDs]);
  var _instance$getData = instance.getData(),
    selectedTabID = _instance$getData.selectedTabID;
  var openedTabIDs = hiddenTabIDs ? hiddenTabIDs.split(',') : [];
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    onClick: clk,
    ref: popperRef,
    className: getClassName(instance)
  }, /*#__PURE__*/_react["default"].createElement(TabsComponent, {
    selectedTabID: selectedTabID,
    openTabIDs: openedTabIDs,
    dir: instance.getOption('direction'),
    isVertical: true
  })));
}