"use strict";

exports.__esModule = true;
exports["default"] = exports.TabsPropsManager = void 0;
var _react = require("react");
var _tabsFactory = _interopRequireDefault(require("./tabs.factory.js"));
var _tab = _interopRequireDefault(require("../tab/tab.js"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var _TabsPropsManager = exports.TabsPropsManager = function TabsPropsManager(ins, props) {
  var dir = props.dir,
    isVertical = props.isVertical;
  var result = {
    className: ins.getSetting('tablistClass') + ' ' + ins.getSetting(dir + "Class")
  };
  if (isVertical) {
    result.className += ' ' + ins.getSetting('verticalClass');
  }
  if (ins.getOption('accessibility')) {
    result.role = 'tablist';
  }
  return result;
};
var _default = exports["default"] = /*#__PURE__*/(0, _react.forwardRef)(_tabsFactory["default"].bind(undefined, function (ins) {
  return {
    Tab: _tab["default"],
    TabsPropsManager: function TabsPropsManager(props) {
      return _TabsPropsManager(ins, props);
    }
  };
}));