"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _api = require("./api.factory");
var _optionManager = _interopRequireDefault(require("./optionManager/optionManager.js"));
var _helper = _interopRequireDefault(require("../helper"));
var _activedTabsHistory = _interopRequireDefault(require("./activedTabsHistory"));
var _pub_sub = _interopRequireDefault(require("./pub_sub.js"));
var _baseApi = _interopRequireDefault(require("./baseApi.js"));
var _tabs = _interopRequireDefault(require("./tabs.js"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var getDeps = function getDeps(options) {
  if (options === void 0) {
    options = {};
  }
  var activedTabsHistory = new _activedTabsHistory["default"](),
    optionsManager = new _optionManager["default"]({
      options: options
    });
  _baseApi["default"].call(this, {
    helper: _helper["default"],
    initialState: optionsManager.initialState
  });
  _tabs["default"].call(this, {
    initialTabs: optionsManager.initialTabs
  });
  _pub_sub["default"].call(this);
  return {
    activedTabsHistory: activedTabsHistory,
    helper: _helper["default"],
    optionsManager: optionsManager
  };
};
_api.apiConstructor.prototype = Object.create(_baseApi["default"].prototype);
var _default = exports["default"] = (_helper["default"].assingAll(_api.apiConstructor.prototype, _tabs["default"].prototype, _pub_sub["default"].prototype, _api.apiProps).constructor = _api.apiConstructor).bind(null, getDeps);